-- name: Vanishable Toad
-- description: Attack Toad and he dies.

sToadScream = audio_stream_load('die.ogg')

define_custom_obj_fields({
    oToadVanishing = 'u32',
})

local function hook_add_loop_to_behavior(id, loop)
    if not id then return end
    local bhv = get_behavior_from_id(id)
    hook_behavior(id, get_object_list_from_behavior(bhv), false, nil, loop)
end

function on_interact(m, o, intType, interacted) --Best place to switch enemy behaviors to have mario insta-die.

    -- Vanishable Toad 
    if ((obj_has_behavior_id(o,id_bhvToadMessage)) ~= 0 and (m.action & ACT_FLAG_ATTACKING) ~= 0) and o.oToadVanishing ~= 1 then
        audio_stream_play(sToadScream, true, 1)
        o.oToadVanishing = 1
    end
    
end

function toad_vanishing(toad)
	if toad.oToadVanishing == 1 then
		toad.oOpacity = toad.oOpacity - 10
		toad.oPosY = toad.oPosY + 10
	else
		toad.oOpacity = 255 
	end
	if toad.oOpacity <= 0 then
		obj_mark_for_deletion(toad)
	end
end

hook_add_loop_to_behavior(id_bhvToadMessage, toad_vanishing)

hook_event(HOOK_ON_INTERACT, on_interact)